﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaseApplicationProject.Models
{
    public class DataItem
    {
        public DataItem()
        {
            this.Children = new ObservableCollection<DataItem>();
            this.Id = Guid.NewGuid().ToString();
        }

        public string Title { get; set; }

        public string Id { get; set; }

        public ObservableCollection<DataItem> Children { get; set; }

        public override int GetHashCode()
        {
            Random r = new Random();
            return base.GetHashCode() ^ r.Next(10, 1000);
        }

        public override bool Equals(object obj)
        {
            DataItem item = obj as DataItem;
            if (item == null)
            {
                throw new ArgumentException("Invalid type. The argument of the Equals method must be DataItem");
            }
            if (item.Id == this.Id)
            {
                return true;
            }
            
            return false;
        }
    }
}
